/*
 * DRV5055-5057EVM DRVGobalVariables.h
 *
 * The header file for declaring variables used by the main.c file
 *
 * Copyright (C) 2018 Texas Instruments Incorporated - http://www.ti.com/
 *
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Patrick Simmons, a0226740
 * Texas Instruments Inc.
 * March 2018
 * Built with Code Composer Studio v5.5
 */

#ifndef DRVGLOBALVARIABLES_H_
#define DRVGLOBALVARIABLES_H_

//********************************************************************************************************************
//Declaration for LCD Variables
extern int LCDSetup(void);
//}Functions that extract a digit from the number to be written on the LCD
extern int d4w(int num);
extern int d3w(int num);
extern int d2w(int num);
extern int d1w(int num);
//}Functions that write the Digit to the LCD
extern int dig1(int num);
extern int dig2(int num);
extern int dig3(int num);
extern int dig4(int num);
extern int decimal(int num);
//}Values that correspond to each of the digits to be displayed on the LCD
extern char d0;
extern char d1;
extern char d2;
extern char d3;

//********************************************************************************************************************
//Declaration for ADC Variables
//
extern int ADCDefaultSetup(void);
extern int DisableADC(void);
//}Function for selecting the ADC Channel of Interest
extern int ADC_SELECT(int num);

extern int ADCChannelChange(void);
extern int ADCSampInit(void);

extern int DeviceRange(void);

extern unsigned int ADC_Result;
//}Voltage Value that corresponds to the ADC value obtained
extern double V_Val;
//int ADCarray[200];
extern unsigned int centerVals[];
extern int N_ave;
extern long sumVal;
extern unsigned int sumC;
extern int oldmemval;
extern int newMemVal;
extern int c_val;
extern double intermediate;
extern double intermediate2;///##############################
extern int Bound[9];
double Sensitivity[9];//={0, .06, .03, .015, .0075, .12, .06, .03, .015};
extern int ErrC;
extern int range[2];
extern int diff;
extern int direction;
extern double mTVal;


//
//
extern int CLKSetup(void);

//********************************************************************************************************************
//Declaration for PWM Variables
extern int PWMSetup(void);
//unsigned int timerAcapturePointer = 0;
extern int PWMSampInit(void);
extern int PWMCanTransition(void);
extern int PWMDRange(void);
extern int PWMCalc(void);
extern int LCDOUT(void);
extern int PWMLCDOUT(void);
extern int Duty2LCDDig(void);
extern int mTOUT(void);
extern int Duty2mTLCD(void);
extern int DisablePWM(void);
extern unsigned int count;
extern unsigned int count1;
extern unsigned int count2;
extern unsigned int Psamples;
extern double Psamples2;   //2=0;
//double DRV57R=0;
extern double Readsum;
extern unsigned int tempVal;
extern unsigned int tempVal2;
extern unsigned int FEC[65];
extern unsigned int REC[65];
extern unsigned int state;
extern unsigned int i;
extern unsigned int i1;
extern double i2;
extern unsigned int i3;
extern double Dsum;
extern double Dave;
extern unsigned int j;
extern double Period;
extern double DutyLow;
extern double duty;
//extern double DArr[129];
extern double PWMcVals[4];
extern double Pdiff;
extern double Prange[2];
extern double PWMBound[4];
extern double PWMSensitivity[4];

//********************************************************************************************************************
//Declaration Pushbutton Variables
extern unsigned char TXData[2];        // {I2C Slave Register Address, I2C Data Byte}
extern char TXByteCtr;
extern unsigned int Device;
extern unsigned int RBit;
extern volatile unsigned char RXData[2];
extern int TXDataLoader(int num);
extern int PBSetup(void);

//extern int catch;
extern int mode;
extern int check;
extern int SetupComplete;

#endif /* DRVGLOBALVARIABLES_H_ */
